<!DOCTYPE html>
<html lang="fr" style="font-family: Arial, Helvetica, sans-serif;">
  <head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>L'armée de Noël - Préparation de potion</title>
  </head>
  <body>
    <div class="prep-panel">
      <div class="prep-top-box">
        <h1 class="prep-title">Préparation</h1>
        <button id="resetButton">Effacer</button>
      </div>
      <div class="verif-box">
        <span>Règles respectées : <span id="reglesOk" class="ok-status">NON</span></span>
        <span>Recette respectée : <span id="recetteOk" class="ok-status">NON</span></span>
      </div>
      <div class="reverse-box">
        <div id="insertEnd" class="insert-end">
          &darr; Insérer à la fin &darr;
        </div>
        <div id="preparationBox">
        </div>
      </div>
    </div>
    <div class="main-panel">
      <div class="ingredients-panel">
        <h1>Essentiel</h1>
        <div class="essentiel-box">
          <button id="melange" class="essentiel-button">Mélanger</button>
          <button id="eau" class="essentiel-button">Eau</button>
        </div>
        <h1>Ingrédients</h1>
        <div id="ingredientBox">
        </div>
      </div>
      <div class="info-panel">
        <h1>Recette</h1>
        <div class="code-box">
          <span>Code du mélange :</span>
          <input id="codeInput" type="text" pattern="\s*(?:(?:[a-zA-Z]+)(?:\s*,\s*[a-zA-Z]+)*)?\s*,?\s*" onkeydown="event.key === 'Enter' ? importPrep() : null"></input>
          <button onclick="importPrep()">Appliquer</button>
        </div>
        <div class="recipe">
          <div class="recipe-ing">
            <span class="recipe-ing-name header">Ingrédient</span>
            <span class="ref-count header">Voulu</span>
            <span class="counter header">Utilisé</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Jus de citron</span>
            <span class="ref-count">2</span>
            <span id="counter_jdc" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Sciure de bois</span>
            <span class="ref-count">2</span>
            <span id="counter_sdb" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Baie de genièvre</span>
            <span class="ref-count">1</span>
            <span id="counter_bdg" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Feuille de blette</span>
            <span class="ref-count">1</span>
            <span id="counter_fdb" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Poils de belette</span>
            <span class="ref-count">1</span>
            <span id="counter_pdb" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Bave de limace</span>
            <span class="ref-count">1</span>
            <span id="counter_bdl" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Houx</span>
            <span class="ref-count">2</span>
            <span id="counter_houx" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Chapon rôti</span>
            <span class="ref-count">1</span>
            <span id="counter_chapon" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Marrons chauds</span>
            <span class="ref-count">2</span>
            <span id="counter_marron" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Farine</span>
            <span class="ref-count">X</span>
            <span id="counter_farine" class="counter">0</span>
          </div>
          <div class="recipe-ing">
            <span class="recipe-ing-name">Eau</span>
            <span class="ref-count">X</span>
            <span id="counter_eau" class="counter">0</span>
          </div>
        </div>
        <h1>Erreurs</h1>
        <div id="errorBox">

        </div>
        <h1>Règles</h1>
        <div class="rule-box">
          <div><i>Notez que l'eau et l'action de mélanger ne comptent jamais comme des doses d'ingrédient.</i></div>
          <div><b>Règle 1 : </b>Toutes les 3 doses d'ingrédient, il faut mettre de l'eau, indépendamment de l'eau éventuellement versée entre les ingrédients.</div>
          <div><b>Règle 2 : </b>Il ne faut pas mettre deux ingrédients identiques à la suite, même en mélangeant entre-temps, sauf pour l'eau.</div>
          <div><b>Règle 3 : </b>Il faut mélanger à chaque fois qu'un liquide est ajouté et seulement dans ce cas.</div>
          <div><b>Règle 4 : </b>Verser de l'eau deux fois de suite retire le premier ingrédient de la potion (eau exclue).</div>
          <div><b>Houx : </b>Le houx ne peut être ajouté qu'après avoir mélangé.</div>
          <div><b>Marron : </b>Les marrons ne doivent pas être ajoutés juste après avoir mis de l'eau.</div>
          <div><b>Poils de belette : </b>Il faut qu'il y ait de la farine dans la potion pour pouvoir ajouter les poils de belette.</div>
          <div><b>Sciure de bois : </b>Il faut mettre de l'eau juste après avoir ajouté la sciure, en plus de l'eau éventuelle de la règle 1.</div>
          <div><b>Jus de citron : </b>Le jus de citron ne doit pas être suivi directement par de l'eau.</div>
          <div><b>Baie de genièvre : </b>La baie de genièvre doit être une des 3 dernières doses d'ingrédient ajoutés à la potion.</div>
          <div><b>Bave de limace : </b>La bave de limace ne doit pas être ajoutée directement après avoir mélangé</div>
        </div>
      </div>
    </div>
	<script>

    ingredients = {
      eau:{name:"Eau", liq:true, dose: 0},
      melange:{name:"Mélanger", dose: 0},
      jdc:{name:"Jus de citron", liq:true},
      farine:{name:"Farine"},
      sdb: {name:"Sciure de bois"},
      bdg: {name:"Baie de genièvre"},
      fdb: {name:"Feuille de blette"},
      pdb: {name:"Poil de belette"},
      bdl: {name:"Bave de limace", liq:true},
      houx: {name:"Houx"},
      chapon: {name: "Chapon rôti", dose: 2},
      marron: {name: "Marron chaud"},
    };
    rulebook = {
      r1:{
        rule:"Règle 1",
        message:"Cet ingrédient est la troisième dose d'une série de 3 doses, il doit être suivi par de l'eau.",
      },
      r1c:{
        rule:"Règle 1",
        message:"Le chapon compte pour 2 doses, mais il ne restait la place que pour 1 dose avant de devoir mettre de l'eau.",
      },
      r2:{
        rule:"Règle 2",
        message:"Cet ingrédient suit un ingrédient identique, il ne peut pas y avoir deux mêmes ingrédients d'affilée.",
      },
      r3a:{
        rule:"Règle 3",
        message:"Il ne faut mélanger qu'après avoir mis un ingrédient liquide.",
      },
      r3b:{
        rule:"Règle 3",
        message:"Cet ingrédient est liquide, il faut donc mélanger juste après.",
      },
      rHoux:{
        rule:"Houx",
        message:"On ne doit mettre du houx qu'après avoir mélangé.",
      },
      rMarron:{
        rule:"Marron",
        message:"Les marrons ne doivent pas être ajoutés juste après avoir mis de l'eau.",
      },
      rPDB:{
        rule:"Poils de belette",
        message:"Il faut avoir mis de la farine dans la potion avant de pouvoir mettre des poils de belette.",
      },
      rSDB:{
        rule:"Sciure de bois",
        message:"La sciure de bois doit immédiatement être suivie d'une dose d'eau (voire 2 si c'est le dernier d'une série de 3 doses d'ingrédient).",
      },
      rJDC:{
        rule:"Jus de citron",
        message:"Le jus de citron ne doit pas être immédiatement suivi par de l'eau.",
      },
      rBDG:{
        rule:"Baie de genièvre",
        message:"La baie de genièvre doit être une des 3 dernières doses d'ingrédient de la préparation.",
      },
      rBDL:{
        rule:"Bave de limace",
        message:"La bave de limace ne doit pas être ajoutée immédiatement après avoir mélangé.",
      },
    }
    prep = [];
    truePrep = [];
    rmList = [];
    errors = [];
    count = {};

    currentPos = -1;

    // ingredients function

    resetIng = () => {
      prep = []
      renderAll()
    }
    
    addIng = (ingId) => {
      if (currentPos == -1) {
        prep.push(ingId)
      } else {
        prep.splice(currentPos, 0, ingId)
        currentPos++
      }
      renderAll()
    }
    
    remIng = (pos) => {
      prep.splice(pos,1)
      if (pos < currentPos) {
        currentPos--;
      }
      renderAll()
    }
    
    setCursor = (pos) => {
      currentPos = pos
      renderAll()
    }

    // recette
    recette = {
      jdc: 2,
      sdb: 2,
      bdg: 1,
      fdb: 1,
      pdb: 1,
      bdl: 1,
      houx: 2,
      chapon: 1,
      marron: 2,
    }

    getTruePrep = (p) => {
      let k = 0
      let prevPrevIng = undefined
      let prevIng = undefined
      const truePrep = p.slice()
      const rmList = []
      for (const ing of p) {
        if (ing === "eau" && prevIng === "eau" || ing === "eau" && prevIng === "melange" && prevPrevIng === "eau") {
          let aRetirer = p[k+rmList.length]
          while (aRetirer === "eau" || aRetirer === "melange") {
            k++;
            aRetirer = p[k+rmList.length]
          }
          if (aRetirer) {
            rmList.push(k + rmList.length)
            truePrep.splice(k, 1)
          } else {
            return [p, []]
          }
        }
        prevPrevIng = prevIng
        prevIng = ing
      }
      return [truePrep, rmList]
    }

    countIngs = (p) => {
      const count = {}
      for (const ing of p) {
        count[ing] = (count[ing] || 0) + 1
      }
      return count
    }

    checkRecette = (count) => {
      for (const ing in recette) {
        if (recette[ing] !== count[ing]) return false;
      }
      if (count["eau"] !== count["farine"]) return false;
      return true
    }

    // regles

    shiftWithRm = (k, rm) => {
      return rm.reduce((acc,curr) => curr <= acc ? acc + 1 : acc, k)
    }

    countDoses = (p, k=undefined) => p.slice(0,k).reduce((acc,curr) => acc + (ingredients[curr].dose ?? 1), 0)

    checkRegles = (p) => {
      const errors = []
      for (let k = 0; k < p.length; k++) {
        // regle 1
        if (!["eau","melange"].includes(p[k]) && countDoses(p,k+1) % 3 === 0) {
          if (!(p[k+1] === "eau" || p[k+1] === "melange" && p[k+2] === "eau")) {
            if (!errors[k]) errors[k] = [];
            errors[k].push(rulebook.r1)
          }
        }
        if (p[k] === "chapon" && countDoses(p,k)%3 === 2) {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.r1c)
        }
        
        // regle 2
        if (p[k] !== "eau" ) {
          let r = 1
          let prevIng = p[k-r]
          while (prevIng === "melange") {
            r++
            prevIng = p[k-r]
          }
          if (prevIng === p[k]) {
            if (!errors[k]) errors[k] = [];
            errors[k].push(rulebook.r2)
          }
        }
        
        // regle 3
        if (p[k] === "melange" && !ingredients[p[k-1]]?.liq) {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.r3a)
        }
        if (ingredients[p[k]].liq && p[k+1] !== "melange") {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.r3b)
        }
        
        // regle houx
        if (p[k] === "houx" && p[k-1] !== "melange") {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.rHoux)
        }
        
        // regle marrons
        if (p[k] === "marron" && p[k-2] === "eau") {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.rMarron)
        }
        
        // regle poils de belette
        if (p[k] === "pdb" && !p.slice(0,k).includes("farine")) {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.rPDB)
        }
        
        // regle sciure de bois
        if (p[k] === "sdb" && (p[k+1] !== "eau" || countDoses(p,k+1)%3 === 0 && p[k+3] !== "eau")) {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.rSDB)
        }
        
        // regle jus de citron
        if (p[k] === "jdc" && p[k+2] === "eau") {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.rJDC)
        }
        
        // regle baie de genièvre
        if (p[k] === "bdg" && p.slice(k+1).reduce((acc,curr) => acc+(ingredients[curr].dose ?? 1), 0) > 2) {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.rBDG)
        }
        
        // regle bave de limace
        if (p[k] === "bdl" && p[k-1] === "melange") {
          if (!errors[k]) errors[k] = [];
          errors[k].push(rulebook.rBDL)
        }
      }
      return errors
    }

    // render functions
    
    renderPreparation = () => {
      const newContent = []
      const shiftedErrorPos = errors.map((e,k) => shiftWithRm(k, rmList))
      for (let k = 0; k < prep.length; k++) {
        if (currentPos === k) {
          const newEl = document.createElement("div")
          newEl.classList.add("cursor")
          newContent.push(newEl)
        }
        
        const newEl = document.createElement("div")
        newEl.classList.add("prep-line")
        if (shiftedErrorPos.includes(k)) {
          newEl.classList.add("error")
          const err = errors[shiftedErrorPos.indexOf(k)]
          newEl.title = `Erreur${err.length>1?'s':''} : ${err.map(e=>e.rule).join(", ")}`
        }
        
        const ingName = document.createElement("span")
        ingName.classList.add("ing-name")
        ingName.textContent = `${k+1}. ${ingredients[prep[k]].name}`
        if (rmList.includes(k)) {
          ingName.classList.add("removed")
          ingName.title = "Ingrédient supprimé selon la Règle 4"
        }
        newEl.appendChild(ingName)
        
        const insertBefore = document.createElement("button")
        insertBefore.classList.add("insert-before")
        insertBefore.textContent = "\uD83E\uDC45"
        insertBefore.title = "Insérer au dessus"
        insertBefore.addEventListener("click", () => setCursor(k))
        newEl.appendChild(insertBefore)

        const delIng = document.createElement("button")
        delIng.classList.add("del-ing")
        delIng.textContent = "\u274C"
        delIng.title = "Supprimer"
        delIng.addEventListener("click", () => remIng(k))
        newEl.appendChild(delIng)
        
        
        newContent.push(newEl)
      }
      if (currentPos === -1) {
        const newEl = document.createElement("div")
        newEl.classList.add("cursor")
        newContent.push(newEl)
      }
      updateDivList(preparationBox, newContent)
    }

    updateDivList = (box, newContent) => {
      for (let k = 0; k < newContent.length; k++) {
        if (box.children[k]) {
          box.replaceChild(newContent[k], box.children[k])
        } else {
          box.appendChild(newContent[k])
        }
      }
      for (let k = box.children.length - 1; k >= newContent.length; k--) {
        box.removeChild(box.children[k])
      }
    }

    renderRecette = () => {
      if (checkRecette(count)) {
        recetteOk.textContent = "OUI"
        recetteOk.classList.add("oui")
        recetteOk.classList.remove("non")
      } else {
        recetteOk.textContent = "NON"
        recetteOk.classList.add("non")
        recetteOk.classList.remove("oui")
      }
      for (const key in ingredients) {
        if (window[`counter_${key}`]) {
          window[`counter_${key}`].textContent = `${count[key] ?? 0}`
        }
      }
    }

    renderErrors = () => {
      if (errors.length === 0) {
        reglesOk.textContent = "OUI"
        reglesOk.classList.add("oui")
        reglesOk.classList.remove("non")
        errorBox.innerHTML = "Aucune erreur."
      } else {
        reglesOk.textContent = "NON"
        reglesOk.classList.add("non")
        reglesOk.classList.remove("oui")
        errorBox.innerHTML = errors.map((err,k) => (err ?? []).map(e => `<span><b>Position ${shiftWithRm(k,rmList)+1} : ${e.rule} :</b> ${e.message}</span>`).join("\n")).join("\n")
      }


    }

    renderAll = () => {
      if (currentPos >= prep.length) {
        currentPos = -1
      }

      [truePrep, rmList] = getTruePrep(prep)
      count = countIngs(truePrep)
      errors = checkRegles(truePrep)
      updateCode()

      renderRecette()
      renderErrors()
      renderPreparation()

      if (currentPos === -1) {
        insertEnd.classList.add("hidden")
      } else {
        insertEnd.classList.remove("hidden")
      }
    }

    // init functions

    initIngredients = () => {
      const newContent = []
      for (const key of Object.keys(ingredients).sort()) {
        if (["eau","melange"].includes(key)) continue;
        const newEl = document.createElement("button")
        newEl.id = key
        newEl.classList.add("ing-item")
        newEl.textContent = ingredients[key].name
        newEl.addEventListener("click", () => addIng(key))
        newContent.push(newEl)
      }
      updateDivList(ingredientBox, newContent)
    }

    initAll = () => {
      eau.addEventListener("click", () => addIng("eau"))
      melange.addEventListener("click", () => addIng("melange"))
      resetButton.addEventListener("click", () => resetIng())
      insertEnd.addEventListener("click", () => setCursor(-1))
      initIngredients()
      codeInput.focus()
      renderAll()
    }

    addEventListener("load", initAll)

    // code
    exportPrep = () => {
      console.log(prep.join(","))
    }
    
    updateCode = () => {
      codeInput.value = prep.join(",")
    }

    importPrep = () => {
      if (codeInput.reportValidity()) {
        txt = codeInput.value.trim().toLowerCase()
        if (txt[txt.length-1] === ",") {
          txt = txt.slice(0,txt.length-1).trim()
        }
        if (!/^(([a-z]+)(\s*,\s*[a-z]+)*)?$/.test(txt)) {
          console.error("Invalid code.")
          alert("Code invalide.")
          codeInput.value = ""
          return
        }
        let newPrep
        if (txt) {
          newPrep = txt.toLowerCase().split(",").map(ing => ing.trim())
        } else {
          newPrep = []
        }
        if (newPrep.some((ing) => !Object.keys(ingredients).includes(ing))) {
          console.error("Some ingredients are invalid.")
          alert("Certains ingrédients sont incorrects.")
          codeInput.value = ""
          return
        }
        prep = newPrep
        renderAll()
      }
    }

  </script>
  </body>
  <style>
    h1 {
      margin: 12px
    }

    button {
      border: 1px solid black;
      border-radius: 10px;
      cursor: pointer;
      min-height: 24px;
    }

    html, body {
      height: 100%;
      margin: 0;
      padding: 0;
    }

    body {
      display:flex;
      box-sizing: border-box;
      flex-direction: row;
    }

    .main-panel {
      flex-basis: max(66%,250px);
      box-sizing: border-box;
      display: flex;
      flex-direction: row;
    }
    
    .info-panel {
      max-height: 100%;
      overflow-y: auto;
      flex: 1 0 250px;
      padding: 16px;
      box-sizing: border-box;
      background-color: lightskyblue;
      display: flex;
      flex-direction: column;
      align-items: center;
      gap: 8px;
    }
    
    .code-box {
      display: flex;
      flex-direction: row;
      flex-wrap: wrap;
      gap: 8px;
      margin-bottom: 16px;
    }

    .recipe {
      width: 100%;
      display: flex;
      flex-direction: column;
      gap: 4px;
      justify-content: space-between;
    }

    .recipe-ing {
      display: flex;
      flex-direction: row;
      align-items: center;
      gap: 4px;
    }

    .recipe-ing-name {
      margin-right: auto;
      flex-shrink: 1;
    }

    .counter, .ref-count {
      flex-shrink: 0;
      width: 50px;
      text-align: center;
    }

    .header {
      font-weight: bolder;
    }
    
    #errorBox {
      display: flex;
      flex-direction: column;
      gap: 4px;
    }

    .rule-box {
      display: flex;
      flex-direction: column;
      gap: 4px;
    }

    .ingredients-panel {
      max-height: 100%;
      overflow-y: auto;
      flex: 1 0 250px;
      padding: 16px;
      padding-bottom: 24px;
      box-sizing: border-box;
      background-color: burlywood;
      display: flex;
      flex-direction: column;
      align-items: center;
      gap: 8px;
    }

    .essentiel-box {
      display: flex;
      flex-direction: row;
      gap: 16px;
      flex-wrap: wrap;
      justify-content: space-evenly;
    }

    .essentiel-button {
      background-color: lawngreen;
      width: 100px;
      height: 60px;
      font-size: large;
    }

    #ingredientBox {
      display: flex;
      flex-direction: row;
      gap: 16px;
      flex-wrap: wrap;
      justify-content: center;
    }

    .ing-item {
      background-color: lawngreen;
      width: 100px;
      height: 60px;
      font-size: large;
    }

    .prep-panel {
      flex-shrink: 0;
      flex-basis: max(34%,200px);
      height: 100%;
      overflow: auto;
      box-sizing: border-box;
      padding: 16px;
      display: flex;
      flex-direction: column;
      gap: 16px;
      align-items: center;
    }

    .prep-top-box {
      display: flex;
      flex-direction: row;
      flex-wrap: wrap;
      gap: 8px;
      align-items: center;
      width: 100%;
    }

    .prep-title {
      margin: 12px 0;
    }

    #resetButton {
      width: 80px;
      height: 30px;
      margin-left: auto;
    }

    .verif-box {
      display: flex;
      flex-direction: row;
      flex-wrap: wrap;
      gap: 8px;
      align-items: center;
      width: 100%;
      justify-content: space-between;
    }

    .reverse-box {
      display: flex;
      flex-direction: column-reverse;
      overflow: auto;
      width: 100%;
      min-height: 60px;
      align-items: center;
      gap: 4px;
    }

    #preparationBox {
      display: flex;
      flex-direction: column;
      gap: 8px;
      width: 100%;
    }

    .prep-line {
      background-color: lawngreen;
      display: flex;
      flex-direction: row;
      gap: 8px;
      align-items: center;
      border-radius: 10PX;
      padding: 4px 8px;
    }

    .prep-line.error {
      background-color: orangered;
    }

    .insert-end {
      cursor: pointer;
      border-radius: 10px;
      border: 1px dashed black;
      padding: 8px;
    }

    .ing-name {
      margin-right: auto;
    }

    .ing-name.removed {
      text-decoration: line-through;
    }

    .insert-before {
      flex-shrink: 0;
      border-radius: 9999px;
      width:28px;
      height:28px;
      padding: 0;
    }

    .del-ing {
      flex-shrink: 0;
      border-radius: 9999px;
      width:28px;
      height:28px;
      padding: 0;
    }

    .hidden {
      display: none;
    }

    .cursor {
      background-color: black;
      border-radius: 9999px;
      height: 2px;
      display: block;
      animation: blinker 2s linear infinite;
    }

    .ok-status {
      font-size: large;
    }

    .ok-status.oui {
      color: lawngreen;
    }

    .ok-status.non {
      color: red;
    }

    @keyframes blinker {
      50% {
        background: none;
      }
    }

    @media (max-width: 450px) {
      body {
        flex-direction: column;
        min-height: 450px;
        overflow-y: auto;
      }

      h1 {
        margin: 8px;
        font-size: larger;
      }

      .main-panel {
        flex-shrink: 0;
        flex-basis: max(60%,250px);
        overflow-x: hidden;
      }

      .prep-panel {
        flex-shrink: 0;
        flex-basis: max(40%,200px);
      }
    }

    @media (max-width: 756px) {
      .main-panel {
        flex-direction: column;
        max-height: 100%;
        overflow-y: auto;
      }

      .info-panel {
        overflow: visible;
        max-height: max-content;
      }
      
      .ingredients-panel {
        overflow: visible;
        max-height: max-content;
      }

      .prep-line {
        gap: 4px;
      }
    }
  </style>
</html>